package se.softstuff.nb.nbtranslate.ide.importw;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import javax.swing.JPanel;
import org.openide.util.NbBundle;
import se.softstuff.nb.nbtranslate.data.NbTranslation;
import se.softstuff.nb.nbtranslate.swing.ColumnRenderer;
import se.softstuff.nb.nbtranslate.swing.DynamicTableModel;


public final class ImportVisualLanguagePanel extends JPanel {

    private DynamicTableModel<LanguateRow> tableModel;
    public ImportVisualLanguagePanel() {
        tableModel = new DynamicTableModel<LanguateRow>();
        tableModel.addColumn(new LocaleRender(), new InToBeImportedRender());
        
        initComponents();
        
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(ImportVisualLanguagePanel.class, "ImportVisualPanel3.bulletin");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        languateTable = new javax.swing.JTable();

        setName("Form"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ImportVisualLanguagePanel.class, "ImportVisualLanguagePanel.jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        languateTable.setModel(tableModel);
        languateTable.setName("languateTable"); // NOI18N
        jScrollPane1.setViewportView(languateTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(15, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable languateTable;
    // End of variables declaration//GEN-END:variables

    
    Set<String> getToTranslateLocale() {
        Set<String> languages = new HashSet<String>();
        for(LanguateRow row : tableModel.getRows()) {
            if(row.importLocale){
                languages.add(row.locale);
            }
        }
        return languages;
    }

    void init(NbTranslation translation, Set<String> selectedLanguage) {
        
        Set<String> languages = translation.getChangedLanguages();
        List<LanguateRow> rows = new ArrayList<LanguateRow>();
        
        for(String language : languages){
            Boolean importLocale = toBeOrNotToBe(language, selectedLanguage);
            rows.add(new LanguateRow(language, importLocale));
        }
        tableModel.setRows(rows);
    }

    private Boolean toBeOrNotToBe(String language, Set<String> selectedLanguage) {
        return selectedLanguage == null || selectedLanguage.contains(language);
    }
    
    private static class LanguateRow {
        String locale;
        Boolean importLocale;

        public LanguateRow(String locale, Boolean importLocale) {
            this.locale = locale;
            this.importLocale = importLocale;
        }
    }
    
    private static class LocaleRender extends ColumnRenderer<LanguateRow, String>{

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualLanguagePanel.class, "LocaleRender.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualLanguagePanel.class, "LocaleRender.header.tooltip");
        }

        @Override
        public String render(LanguateRow row) {
            return row.locale;
        }
        
    }
    
    private static class InToBeImportedRender extends ColumnRenderer<LanguateRow, Boolean>{

        @Override
        public String headerText() {
            return NbBundle.getMessage(ImportVisualLanguagePanel.class, "InToBeImportedRender.header.text");
        }

        @Override
        public String headerTooltip() {
            return NbBundle.getMessage(ImportVisualLanguagePanel.class, "InToBeImportedRender.header.tooltip");
        }

        @Override
        public Boolean render(LanguateRow row) {
            return row.importLocale;
        }
        
        @Override
        public boolean isCellEditable(LanguateRow row) {
            return true;
        }

        @Override
        public void setValueAt(LanguateRow row, Boolean aValue) {
            row.importLocale = aValue;
        }
        
    }
}
